diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java b/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
similarity index 77%
rename from src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
rename to src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
index 939c74685..fa243d89e 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntitySign.java
+++ b/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
@@ -1,16 +1,22 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet140TileEntityData;
+import net.minecraft.core.net.packet.BlockEntityDataPacket;
 
-public class TileEntitySign extends TileEntity
+public class SignBlockEntity extends BlockEntity
 {
+    public String[] signText = { "", "", "", "" };
+    public int lineBeingEdited;
+    private int selectedPicture = 0;
+    private int selectedColor = 15;
+    private String owner = "";
+    private boolean glowing = false;
 
-    public TileEntitySign()
+    public SignBlockEntity()
     {
         lineBeingEdited = -1;
     }
@@ -25,6 +31,7 @@ public class TileEntitySign extends TileEntity
         tag.putString("Text4", signText[3]);
         tag.putInt("Picture", selectedPicture);
         tag.putInt("Color", selectedColor);
+        tag.putBoolean("Glowing", glowing);
         tag.putString("Owner", owner);
     }
 
@@ -42,18 +49,19 @@ public class TileEntitySign extends TileEntity
         }
         selectedPicture = tag.getIntegerOrDefault("Picture", 0);
         selectedColor = tag.getIntegerOrDefault("Color", 15);
+        glowing = tag.getBooleanOrDefault("Glowing", false);
         owner = tag.getString("Owner");
     }
     
-    public boolean getIsEditable(EntityPlayer player)
+    public boolean isEditableBy(Player player)
     {
         return player.username.equals(owner);
     }
-    public void setOwner(EntityPlayer player){
+
+    public void setOwner(Player player){
         this.owner = player.username;
     }
 
-
     public EnumSignPicture getPicture()
     {
         if (selectedPicture < 0) return null;
@@ -88,18 +96,18 @@ public class TileEntitySign extends TileEntity
     {
         selectedColor = color.id;
     }
+
+    public boolean isGlowing() {
+        return glowing;
+    }
+
+    public void setGlowing(boolean glowing) {
+        this.glowing = glowing;
+    }
     
     @Override
 	public Packet getDescriptionPacket()
     {
-        return new Packet140TileEntityData(this);
+        return new BlockEntityDataPacket(this);
     }
-
-    public String[] signText = {
-        "", "", "", ""
-    };
-    public int lineBeingEdited;
-    private int selectedPicture = 0;
-    private int selectedColor = 15;
-    private String owner = "";
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
rename to src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
index 2fd6dfb81..094d8a83e 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityTrommel.java
+++ b/src/main/java/net/minecraft/core/block/entity/TrommelBlockEntity.java
@@ -4,16 +4,18 @@ package net.minecraft.core.block.entity;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockChest;
-import net.minecraft.core.block.BlockTrommel;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.ChestBlock;
+import net.minecraft.core.block.TrommelBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.entity.monster.EntitySlime;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.monster.SlimeMob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.MathHelper;
 
 import java.util.HashMap;
@@ -21,11 +23,11 @@ import java.util.List;
 import java.util.Map;
 import java.util.Random;
 
-public class TileEntityTrommel extends TileEntity
-        implements IInventory
+public class TrommelBlockEntity extends BlockEntity
+        implements Container
 {
 
-    public TileEntityTrommel()
+    public TrommelBlockEntity()
     {
         itemStacks = new ItemStack[5];
         burnTime = 0;
@@ -40,32 +42,32 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-	public int getSizeInventory()
+	public int getContainerSize()
     {
         return itemStacks.length;
     }
 
     @Override
-	public ItemStack getStackInSlot(int i)
+	public ItemStack getItem(int index)
     {
-        return itemStacks[i];
+        return itemStacks[index];
     }
 
     @Override
-	public ItemStack decrStackSize(int i, int j)
+	public ItemStack removeItem(int index, int takeAmount)
     {
-        if(itemStacks[i] != null)
+        if(itemStacks[index] != null)
         {
-            if(itemStacks[i].stackSize <= j)
+            if(itemStacks[index].stackSize <= takeAmount)
             {
-                ItemStack itemstack = itemStacks[i];
-                itemStacks[i] = null;
+                ItemStack itemstack = itemStacks[index];
+                itemStacks[index] = null;
                 return itemstack;
             }
-            ItemStack itemstack1 = itemStacks[i].splitStack(j);
-            if(itemStacks[i].stackSize <= 0)
+            ItemStack itemstack1 = itemStacks[index].splitStack(takeAmount);
+            if(itemStacks[index].stackSize <= 0)
             {
-                itemStacks[i] = null;
+                itemStacks[index] = null;
             }
             return itemstack1;
         } else
@@ -75,17 +77,17 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-	public void setInventorySlotContents(int i, ItemStack itemstack)
+	public void setItem(int index, ItemStack itemstack)
     {
-        itemStacks[i] = itemstack;
-        if(itemstack != null && itemstack.stackSize > getInventoryStackLimit())
+        itemStacks[index] = itemstack;
+        if(itemstack != null && itemstack.stackSize > getMaxStackSize())
         {
-            itemstack.stackSize = getInventoryStackLimit();
+            itemstack.stackSize = getMaxStackSize();
         }
     }
 
     @Override
-	public String getInvName()
+	public String getName()
     {
         return "Trommel";
     }
@@ -95,7 +97,7 @@ public class TileEntityTrommel extends TileEntity
     {
         super.readFromNBT(nbttagcompound);
         ListTag nbttaglist = nbttagcompound.getList("Items");
-        itemStacks = new ItemStack[getSizeInventory()];
+        itemStacks = new ItemStack[getContainerSize()];
         for(int i = 0; i < nbttaglist.tagCount(); i++)
         {
             CompoundTag nbttagcompound1 = (CompoundTag)nbttaglist.tagAt(i);
@@ -133,7 +135,7 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-	public int getInventoryStackLimit()
+	public int getMaxStackSize()
     {
         return 64;
     }
@@ -170,12 +172,12 @@ public class TileEntityTrommel extends TileEntity
         }
         if(worldObj != null && !worldObj.isClientSide)
         {
-        	if(worldObj.getBlockId(x, y, z) == Block.trommelIdle.id) {
+        	if(worldObj.getBlockId(x, y, z) == Blocks.TROMMEL_IDLE.id) {
             	if(currentItemBurnTime == 0 && itemStacks[0] == null) {
-            		if(itemStacks[4] != null && itemStacks[4].itemID == Block.netherrack.id) {
+            		if(itemStacks[4] != null && itemStacks[4].itemID == Blocks.NETHERRACK.id) {
             			itemStacks[4].stackSize--;
             			if(itemStacks[4].stackSize <= 0) itemStacks[4] = null;
-            			BlockTrommel.updateTrommelBlockState(true, worldObj, x, y, z);
+            			TrommelBlock.updateTrommelBlockState(true, worldObj, x, y, z);
             			flag1 = true;
             		}
             	}
@@ -190,8 +192,8 @@ public class TileEntityTrommel extends TileEntity
                     flag1 = true;
                     if(itemStacks[4] != null)
                     {
-                    	if(itemStacks[4].getItem() == Item.bucketLava) {
-                    		itemStacks[4] = new ItemStack(Item.bucket);
+                    	if(itemStacks[4].getItem() == Items.BUCKET_LAVA) {
+                    		itemStacks[4] = new ItemStack(Items.BUCKET);
                     	}else {
                             itemStacks[4].stackSize--;
                             if(itemStacks[4].stackSize <= 0)
@@ -219,12 +221,12 @@ public class TileEntityTrommel extends TileEntity
             if(isBurning != (burnTime > 0))
             {
                 flag1 = true;
-                BlockTrommel.updateTrommelBlockState(burnTime > 0, worldObj, x, y, z);
+                TrommelBlock.updateTrommelBlockState(burnTime > 0, worldObj, x, y, z);
             }
         }
         if(flag1)
         {
-            onInventoryChanged();
+            setChanged();
         }
     }
 
@@ -272,21 +274,21 @@ public class TileEntityTrommel extends TileEntity
         	}
         	int adjacentId = worldObj.getBlockId(x + xOffset, y, z + zOffset);
         	
-        	IInventory chest = null;
-        	if (Block.blocksList[adjacentId] instanceof BlockChest) {
-        		chest = BlockChest.getInventory(worldObj, x + xOffset, y, z + zOffset);
+        	Container chest = null;
+        	if (Block.blocksList[adjacentId] instanceof ChestBlock) {
+        		chest = ChestBlock.getInventory(worldObj, x + xOffset, y, z + zOffset);
         	}
         	
         	if (chest != null)
         	{
-        		for (int i = 0; i < chest.getSizeInventory(); i++)
+        		for (int i = 0; i < chest.getContainerSize(); i++)
         		{
-        			ItemStack slot = chest.getStackInSlot(i);
+        			ItemStack slot = chest.getItem(i);
         			if (slot != null && slot.itemID == itemResult.itemID && slot.getMetadata() == itemResult.getMetadata())
         			{
                         for(; slot.stackSize + 1 <= slot.getMaxStackSize(); itemResult.stackSize--){
                             slot.stackSize ++;
-                            chest.setInventorySlotContents(i, slot);
+                            chest.setItem(i, slot);
                             if(itemResult.stackSize <= 0)
                                 return;
                         }
@@ -294,13 +296,13 @@ public class TileEntityTrommel extends TileEntity
         		}
                 if(itemResult.stackSize <= 0)
                     return;
-        		for (int i = 0; i < chest.getSizeInventory(); i++)
+        		for (int i = 0; i < chest.getContainerSize(); i++)
         		{
-        			ItemStack slot = chest.getStackInSlot(i);
+        			ItemStack slot = chest.getItem(i);
         			if (slot == null)
         			{
 
-        				chest.setInventorySlotContents(i, itemResult);
+        				chest.setItem(i, itemResult);
         				return;
         			}
         		}
@@ -313,7 +315,7 @@ public class TileEntityTrommel extends TileEntity
 
             float f = (((float) 1 - 0.5F)) / 4F;
             float f1 = (((float) 1 - 0.5F)) / 4F;
-            EntitySlime entityslime = new EntitySlime(worldObj);
+            SlimeMob entityslime = new SlimeMob(worldObj);
             entityslime.setSlimeSize(1);
             entityslime.moveTo(x + (double)f, y + 1D, z + (double)f1, rand.nextFloat() * 360F, 0.0F);
             float f3 = 0.05F;
@@ -360,9 +362,9 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-	public boolean canInteractWith(EntityPlayer entityplayer)
+	public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockTileEntity(x, y, z) != this)
+        if(worldObj.getBlockEntity(x, y, z) != this)
         {
             return false;
         }
@@ -370,7 +372,7 @@ public class TileEntityTrommel extends TileEntity
     }
 
     @Override
-    public void sortInventory() {
+    public void sortContainer() {
         // Do nothing
     }
 
diff --git a/src/main/java/net/minecraft/core/block/logic/RailDirection.java b/src/main/java/net/minecraft/core/block/logic/RailDirection.java
new file mode 100644
index 000000000..0467a8afa
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/logic/RailDirection.java
@@ -0,0 +1,109 @@
+package net.minecraft.core.block.logic;
+
+import org.jetbrains.annotations.NotNull;
+
+import java.util.HashMap;
+import java.util.Map;
+
+public enum RailDirection {
+    NONE(-1, false, false, false,
+        0, 0, 0,
+        0, 0, 0),
+    STRAIGHT_NS(0, false, true, false,
+        0, 0, 1,
+        0, 0, -1),
+    STRAIGHT_EW(1, false, true, false,
+        -1, 0, 0,
+        1, 0, 0),
+    SLOPE_E(2, true, false, false,
+        -1, 0, 0,
+        1, 1, 0),
+    SLOPE_W(3, true, false, false,
+        -1, 1, 0,
+        1, 0, 0),
+    SLOPE_N(4, true, false, false,
+        0, 0, 1,
+        0, 1, -1),
+    SLOPE_S(5, true, false, false,
+        0, 1, 1,
+        0, 0, -1),
+    TURN_ES(6, false, false, true,
+        0, 0, 1,
+        1, 0, 0),
+    TURN_WS(7, false, false, true,
+        0, 0, 1,
+        -1, 0, 0),
+    TURN_WN(8, false, false, true,
+        0, 0, -1,
+        -1, 0, 0),
+    TURN_EN(9, false, false, true,
+        0, 0, -1,
+        1, 0, 0);
+
+    private static final Map<Integer, RailDirection> directionMap = new HashMap<>();
+    public final int meta;
+    private final boolean sloped;
+    private final boolean straight;
+    private final boolean curved;
+    private final int offX1;
+    private final int offY1;
+    private final int offZ1;
+    private final int offX2;
+    private final int offY2;
+    private final int offZ2;
+
+    RailDirection(int meta, boolean sloped, boolean straight, boolean curved,
+                  int offX1, int offY1, int offZ1,
+                  int offX2, int offY2, int offZ2){
+        this.meta = meta;
+        this.sloped = sloped;
+        this.straight = straight;
+        this.curved = curved;
+        this.offX1 = offX1;
+        this.offY1 = offY1;
+        this.offZ1 = offZ1;
+        this.offX2 = offX2;
+        this.offY2 = offY2;
+        this.offZ2 = offZ2;
+    }
+    public int getNextRailX(){
+        return offX1;
+    }
+    public int getNextRailY(){
+        return offY1;
+    }
+    public int getNextRailZ(){
+        return offZ1;
+    }
+    public int getPrevRailX(){
+        return offX2;
+    }
+    public int getPrevRailY(){
+        return offY2;
+    }
+    public int getPrevRailZ(){
+        return offZ2;
+    }
+    public boolean isSloped(){
+        return sloped;
+    }
+    public boolean isStraight(){
+        return straight;
+    }
+    public boolean isCurved(){
+        return curved;
+    }
+    @NotNull
+    public static RailDirection getFromMeta(int meta){
+        if (directionMap.containsKey(meta)){
+            return directionMap.get(meta);
+        }
+        return NONE;
+    }
+
+    static {
+        for (RailDirection d : values()){
+            directionMap.put(d.meta, d);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/logic/RedstoneUpdateInfo.java b/src/main/java/net/minecraft/core/block/logic/RedstoneUpdateInfo.java
index a58220590..133508cf0 100644
--- a/src/main/java/net/minecraft/core/block/logic/RedstoneUpdateInfo.java
+++ b/src/main/java/net/minecraft/core/block/logic/RedstoneUpdateInfo.java
@@ -1,15 +1,17 @@
 package net.minecraft.core.block.logic;
 
 
-public class RedstoneUpdateInfo
-{
+public class RedstoneUpdateInfo {
+    private final int x;
+    private final int y;
+    private final int z;
+    private final long updateTime;
 
-    public RedstoneUpdateInfo(int i, int j, int k, long l)
-    {
-        x = i;
-        y = j;
-        z = k;
-        updateTime = l;
+    public RedstoneUpdateInfo(int x, int y, int z, long updateTime) {
+        this.x = x;
+        this.y = y;
+        this.z = z;
+        this.updateTime = updateTime;
     }
 
     public int getXCoord(){
@@ -24,9 +26,4 @@ public class RedstoneUpdateInfo
     public long getUpdateTime(){
         return updateTime;
     }
-
-    int x;
-    int y;
-    int z;
-    long updateTime;
 }
diff --git a/src/main/java/net/minecraft/core/block/material/Material.java b/src/main/java/net/minecraft/core/block/material/Material.java
index eb34c413b..6d2253f0b 100644
--- a/src/main/java/net/minecraft/core/block/material/Material.java
+++ b/src/main/java/net/minecraft/core/block/material/Material.java
@@ -2,12 +2,18 @@ package net.minecraft.core.block.material;
 
 public class Material
 {
+    public static final int LIGHTNING_NEUTRAL = 0;
+    public static final int LIGHTNING_STRONG_CONDUCTOR = 20;
+    public static final int LIGHTNING_LIGHT_CONDUCTOR = 5;
+    public static final int LIGHTNING_LIGHT_INSULATOR = -5;
+    public static final int LIGHTNING_STRONG_INSULATOR = -20;
     private boolean flammable;
     private boolean replaceable;
     private boolean notSolidBlocking;
     public final MaterialColor color;
     private boolean alwaysDestroyable;
     private int pushReaction;
+    private int lightningConductivity = LIGHTNING_NEUTRAL;
 
     public Material(MaterialColor color)
     {
@@ -35,19 +41,19 @@ public class Material
         return true;
     }
 
-    private Material notSolidBlocking()
+    public Material notSolidBlocking()
     {
         notSolidBlocking = true;
         return this;
     }
 
-    private Material notAlwaysDestroyable()
+    public Material notAlwaysDestroyable()
     {
         alwaysDestroyable = false;
         return this;
     }
 
-    private Material flammable()
+    public Material flammable()
     {
         flammable = true;
         return this;
@@ -91,80 +97,63 @@ public class Material
         return pushReaction;
     }
 
-    protected Material destroyOnPush()
+    public Material destroyOnPush()
     {
         pushReaction = 1;
         return this;
     }
 
-    protected Material notPushable()
+    public Material notPushable()
     {
         pushReaction = 2;
         return this;
     }
-
-    public static final Material air;
-    public static final Material grass;
-    public static final Material dirt;
-    public static final Material wood;
-    public static final Material stone;
-    public static final Material metal;
-    public static final Material water;
-    public static final Material lava;
-    public static final Material leaves;
-    public static final Material plant;
-    public static final Material sponge;
-    public static final Material cloth;
-    public static final Material fire;
-    public static final Material sand;
-    public static final Material decoration;
-    public static final Material glass;
-    public static final Material explosive;
-    public static final Material coral;
-    public static final Material ice;
-    public static final Material topSnow;
-    public static final Material snow;
-    public static final Material cactus;
-    public static final Material clay;
-    public static final Material vegetable;
-    public static final Material portal;
-    public static final Material cake;
-    public static final Material web;
-    public static final Material piston;
-    public static final Material moss;
-    public static final Material woodWet;
-
-    static 
-    {
-        air = new GasMaterial(MaterialColor.none);
-        grass = new Material(MaterialColor.grass);
-        dirt = new Material(MaterialColor.dirt);
-        wood = (new Material(MaterialColor.wood)).flammable();
-        stone = (new Material(MaterialColor.stone)).notAlwaysDestroyable();
-        metal = (new Material(MaterialColor.metal)).notAlwaysDestroyable();
-        water = (new LiquidMaterial(MaterialColor.water)).destroyOnPush();
-        lava = (new LiquidMaterial(MaterialColor.fire)).destroyOnPush();
-        leaves = (new Material(MaterialColor.plant)).flammable().notSolidBlocking().destroyOnPush();
-        plant = (new DecorationMaterial(MaterialColor.plant)).destroyOnPush().replaceable();
-        sponge = new Material(MaterialColor.wool);
-        cloth = (new Material(MaterialColor.wool)).flammable();
-        fire = (new GasMaterial(MaterialColor.none)).destroyOnPush();
-        sand = new Material(MaterialColor.sand);
-        decoration = (new DecorationMaterial(MaterialColor.none)).destroyOnPush();
-        glass = (new Material(MaterialColor.none)).notSolidBlocking();
-        explosive = (new Material(MaterialColor.fire)).flammable().notSolidBlocking();
-        coral = (new Material(MaterialColor.plant)).destroyOnPush();
-        ice = (new Material(MaterialColor.ice)).notSolidBlocking();
-        topSnow = (new DecorationMaterial(MaterialColor.snow)).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
-        snow = (new Material(MaterialColor.snow)).notAlwaysDestroyable();
-        cactus = (new Material(MaterialColor.plant)).notSolidBlocking().destroyOnPush();
-        clay = new Material(MaterialColor.clay);
-        vegetable = (new Material(MaterialColor.plant)).destroyOnPush();
-        portal = (new PortalMaterial(MaterialColor.none)).notPushable();
-        cake = (new Material(MaterialColor.none)).destroyOnPush();
-        web = (new Material(MaterialColor.wool)).notAlwaysDestroyable().destroyOnPush();
-        piston = (new Material(MaterialColor.stone)).notPushable();
-        moss = (new Material(MaterialColor.grass)).flammable().notAlwaysDestroyable();
-        woodWet = (new Material(MaterialColor.grass));
+    public int getConductivity(){
+        return lightningConductivity;
+    }
+    public Material setConductivity(int conductivity){
+        lightningConductivity = conductivity;
+        return this;
     }
+
+
+    public static final Material air = new GasMaterial(MaterialColor.none);
+    public static final Material grass = new Material(MaterialColor.grass);
+    public static final Material dirt = new Material(MaterialColor.dirt);
+    public static final Material wood = new Material(MaterialColor.wood).flammable();
+
+    public static final Material stone = new Material(MaterialColor.stone).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
+    public static final Material basalt = new Material(MaterialColor.basalt).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
+    public static final Material limestone = new Material(MaterialColor.limestone).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
+    public static final Material granite = new Material(MaterialColor.granite).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
+    public static final Material permafrost = new Material(MaterialColor.permafrost).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
+    public static final Material marble = new Material(MaterialColor.marble).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
+    public static final Material slate = new Material(MaterialColor.slate).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
+    public static final Material netherrack = new Material(MaterialColor.netherrack).setConductivity(LIGHTNING_LIGHT_INSULATOR).notAlwaysDestroyable();
+
+    public static final Material metal = new Material(MaterialColor.metal).setConductivity(LIGHTNING_STRONG_CONDUCTOR).notAlwaysDestroyable();
+    public static final Material water = new LiquidMaterial(MaterialColor.water).setConductivity(LIGHTNING_LIGHT_CONDUCTOR).destroyOnPush();
+    public static final Material lava = new LiquidMaterial(MaterialColor.fire).destroyOnPush();
+    public static final Material leaves = new Material(MaterialColor.plant).flammable().notSolidBlocking().destroyOnPush();
+    public static final Material plant = new DecorationMaterial(MaterialColor.plant).destroyOnPush().replaceable();
+    public static final Material sponge = new Material(MaterialColor.wool);
+    public static final Material cloth = new Material(MaterialColor.wool).flammable();
+    public static final Material fire = new GasMaterial(MaterialColor.none).destroyOnPush();
+    public static final Material sand = new Material(MaterialColor.sand);
+    public static final Material decoration = new DecorationMaterial(MaterialColor.none).destroyOnPush();
+    public static final Material glass = new Material(MaterialColor.none).setConductivity(LIGHTNING_STRONG_INSULATOR).notSolidBlocking();
+    public static final Material explosive = new Material(MaterialColor.fire).flammable().notSolidBlocking();
+    public static final Material coral = new Material(MaterialColor.plant).destroyOnPush();
+    public static final Material ice = new Material(MaterialColor.ice).notSolidBlocking();
+    public static final Material topSnow = new DecorationMaterial(MaterialColor.snow).replaceable().notSolidBlocking().notAlwaysDestroyable().destroyOnPush();
+    public static final Material snow = new Material(MaterialColor.snow).notAlwaysDestroyable();
+    public static final Material cactus = new Material(MaterialColor.plant).notSolidBlocking().destroyOnPush();
+    public static final Material clay = new Material(MaterialColor.clay);
+    public static final Material vegetable = new Material(MaterialColor.plant).destroyOnPush();
+    public static final Material portal = new PortalMaterial(MaterialColor.none).notPushable();
+    public static final Material cake = new Material(MaterialColor.none).destroyOnPush();
+    public static final Material web = new Material(MaterialColor.wool).notAlwaysDestroyable().destroyOnPush();
+    public static final Material piston = new Material(MaterialColor.stone).notPushable();
+    public static final Material moss = new Material(MaterialColor.grass).flammable().notAlwaysDestroyable();
+    public static final Material woodWet = (new Material(MaterialColor.grass).setConductivity(LIGHTNING_LIGHT_CONDUCTOR));
 }
